<?php

class Persona_Manager
{

    function process_getfamilies($like, $options)
    {
        $list = RP_Dao_Factory::get_rp_persona_dao()
            ->get_family_list($like, $options);
        return $list;
    }

    function process_getspouses($like, $options)
    {
        $list = RP_Dao_Factory::get_rp_persona_dao()
            ->get_spouses_list($like, $options);
        return $list;
    }

    function process_getfamily($datastr, $options)
    {

    }

    function process_form($parms, $options)
    {
        $isSOR = ($options['is_system_of_record'] == '1' ? true : false);
        $validator = new Persona_Validator();
        $ret = $validator->validate($parms, $options);
        $options = $ret[1];

            if ($isSOR) {
                $handler = new RP_Gedcom_Loader();
                $handler->batch_id = $ret[0]->batch_id;
                $options['editMode'] = 1;
                $indi = $handler->process_individual($ret[0], $options);
            } else {
                $indi = $ret[0];
            }
            if ($indi instanceof RP_Individual_Record) {
                if (isset($indi->id) && !empty($indi->id)) {
                    $page = $indi->page;
                    if ((!isset($page) || empty($page))) {
                        $title = RP_Dao_Factory::get_rp_persona_dao()
                            ->get_fullname($indi->id, $indi->batch_id);
                        $content = "[rootsPersona personId='$indi->id' batchId='$indi->batch_id'"; // Modified by Horacio [personId]
                        for ($i = 1; $i <= 7; $i++) {
                            $pf = 'picfile' . $i;
                            if (isset($indi->images[$i - 1])) {
                                $content = $content . ' ' . $pf . "='" . $indi->images[$i - 1] . "'";
                                $pc = 'piccap' . $i;
                                if (isset($indi->captions[$i - 1])) {
                                    $content = $content . ' ' . $pc . "='" . $indi->captions[$i - 1] . "'";
                                }
                            }
                        }

                        $content = $content . "/]";
                        $page_id = RP_Persona_Helper::add_page(null, $title, $options, null, null, $content); // Modified by Horacio [5 parameters]
                        $indi->page = $page_id;
                        if ($page_id != false) {
                            RP_Dao_Factory::get_rp_indi_dao()
                                ->update_page($indi->id, $indi->batch_id, $page_id);

                            RP_Dao_Factory::get_rp_persona_dao()
                                ->update_persona_privacy($indi->id, $indi->batch_id, $indi->privacy, '');

                        }
                    } else if ($indi->privacy != 'Exc') {
                        $my_post = array();
                        $my_post['ID'] = $page;

                        if ($isSOR) {
                            $title = RP_Dao_Factory::get_rp_persona_dao()
                                ->get_fullname($indi->id, $indi->batch_id);
                            $my_post['post_title'] = $title;
                        }
                        $content = "[rootsPersona personId='$indi->id' batchId='$indi->batch_id'"; // Modified by Horacio [personId]
                        for ($i = 1; $i <= 7; $i++) {
                            $pf = 'picfile' . $i;
                            if (isset($indi->images[$i - 1])) {
                                $content = $content . ' ' . $pf . "='" . $indi->images[$i - 1] . "'";
                                $pc = 'piccap' . $i;
                                if (isset($indi->captions[$i - 1])) {
                                    $content = $content . ' ' . $pc . "='" . $indi->captions[$i - 1] . "'";
                                }
                            }
                        }
                        $content = $content . "/]";
                        $my_post['post_content'] = $content;
                        wp_update_post($my_post);
                        RP_Dao_Factory::get_rp_persona_dao()
                            ->update_persona_privacy($indi->id, $indi->batch_id, $indi->privacy, '');
                    } else {
                        wp_delete_post($page);
                        RP_Dao_Factory::get_rp_persona_dao()
                            ->delete_persona($indi->id, $indi->batch_id);
                        $r = array();
                        $r['error'] = 'Persona deleted.';
                        return $r;
                    }

                }
            } else {
                $r = array();
                $r['error'] = 'Error saving record.';
                return $r;
            }

        $r = array();
        $r['rp_id'] = $indi->id;
        $r['rp_page'] = $indi->page;
        if (isset($indi->parental->id) && !empty($indi->parental->id)) {
            $r['rp_famc'] = $indi->parental->id;
        }
        if (isset($indi->newFams) && !empty($indi->newFams)) {
            $r['rp_fams'] = $indi->newFams;
        }
        return $r;
    }
}
