<?php

class RP_Connection
{

    /**
     *
     * @var resource
     */
    private $connection = null;

    /**
     *
     * @param resource $credentials
     */
    public function __construct($credentials)
    {
        $this->connection = RP_Connection_Factory::get_connection($credentials);
    }

    /**
     *
     */
    public function close()
    {
        RP_Connection_Factory::close($this->connection);
    }

    /**
     *
     * @param mysqli_result
     * @return bool|mysqli_result
     */
    public function execute_query($sql)
    {
        return mysqli_query($this->connection, $sql);
    }

    /**
     * @return bool
     */
    public function begin_transaction()
    {
        return mysqli_begin_transaction($this->connection, MYSQLI_TRANS_START_READ_WRITE);
    }

    /**
     * @return mysqli|resource
     */
    public function get_connection() {
        return $this->connection;
    }

    /**
     *
     */
    public function commit() {
        $this->connection->commit();
    }

    /**
     *
     */
    public function rollback() {
        $this->connection->rollback();
    }
}


