<?php

class RP_Query_Executor
{
    /**
     * @var resource
     */
    private static $connection;

    /**
     *
     * @param string
     * @return array
     * @throws Exception
     */
    public static function execute($sql_query)
    {
        $query = $sql_query->get_query();
        $result = RP_Query_Executor::$connection->execute_query($query);
        if (!$result) {
            throw new Exception(mysqli_error( RP_Query_Executor::$connection->get_connection()));
        }
        $i = 0;
        $tab = array();
        while ($row = mysqli_fetch_array ($result)) {
            $tab[$i++] = $row;
        }
        mysqli_free_result($result);
        return $tab;
    }

    /**
     *
     * @param string $sql_query
     * @return integer
     */
    public static function execute_insert($sql_query)
    {
        RP_Query_Executor::execute_update($sql_query);
        return mysqli_insert_id ( RP_Query_Executor::$connection->get_connection());
    }

    /**
     *
     * @param string $sql_query
     * @param class RP_Credentials $credentials
     * @return int
     * @throws Exception
     */
    public static function execute_update($sql_query)
    {
        $query = $sql_query->get_query();
        $result =  RP_Query_Executor::$connection->execute_query($query);
        if (!$result) {
            throw new Exception(mysqli_error( RP_Query_Executor::$connection->get_connection()));
        }
        return mysqli_affected_rows( RP_Query_Executor::$connection->get_connection());
    }

    /**
     *
     * @param string $sql_query
     * @return string
     * @throws Exception
     */
    public static function query_for_string($sql_query)
    {
        $result =  RP_Query_Executor::$connection->execute_query($sql_query->get_query());
        if (!$result) {
            throw new Exception(mysqli_error( RP_Query_Executor::$connection->get_connection()));
        }
        $row = mysqli_fetch_array($result);
        return $row[0];
    }

    /**
     * @param null $credentials
     * @return resource
     */
    public static function get_connection($credentials = null) {
        if (!RP_Query_Executor::$connection &&  !empty($credentials)) {
            RP_Query_Executor::$connection = new RP_Connection($credentials);
        }
        return RP_Query_Executor::$connection;
    }
}

