<?php

class RP_Sql_Query
{
    var $txt;

    var $params = array();

    var $idx = 0;

    function __construct($txt)
    {
        global $wpdb;
        $txt = str_replace('FROM rp_', 'FROM ' . $wpdb->prefix . 'rp_', $txt);
        $txt = str_replace('INTO rp_', 'INTO ' . $wpdb->prefix . 'rp_', $txt);
        $txt = str_replace('UPDATE rp_', 'UPDATE ' . $wpdb->prefix . 'rp_', $txt);
        $txt = str_replace('JOIN rp_', 'JOIN ' . $wpdb->prefix . 'rp_', $txt);

        $this->txt = $txt;
    }

    public function set_string($value)
    {
        $value = mysqli_real_escape_string(RP_Query_Executor::get_connection()->get_connection(), $value);
        $this->params[$this->idx++] = "'" . $value . "'";
    }

    public function set($value)
    {
        $value = mysqli_real_escape_string(RP_Query_Executor::get_connection()->get_connection(), $value);
        $this->params[$this->idx++] = "'" . $value . "'";
    }

    /**
     *
     * @param int $value
     * @throws Exception
     */
    public function set_number($value)
    {
        if ($value === null) {
            $this->params[$this->idx++] = 'null';
            return;
        }
        if (!is_numeric($value)) {
            throw new Exception($value . ' is not a number');
        }
        $this->params[$this->idx++] = "'" . $value . "'";
        return;
    }

    /**
     *
     * @return string
     */
    public function get_query()
    {
        if ($this->idx == 0) {
            return $this->txt;
        }
        $p = explode('?', $this->txt);
        $sql = '';
        for ($i = 0; $i <= $this->idx; $i++) {
            if ($i >= count($this->params)) {
                $sql .= $p[$i];
            } else {
                $sql .= $p[$i] . $this->params[$i];
            }
        }
        return $sql;
    }
}

