<?php

/**
 * Database transaction
 *
 * @author: http://phpdao.com
 * @date: 27.11.2007
 */
class RP_Transaction
{

    /**
     *
     * @var resource
     */
    private static $transaction;

    /**
     *
     * @var resource
     */
    private $connection;

    /**
     *
     * @param class RP_Credentials $credentials
     * @param boolean $is_query
     */
    public function __construct($credentials)
    {
        if (!RP_Transaction::$transaction) {
            RP_Transaction::$transaction = $this;
        }
        $this->connection = new RP_Connection($credentials);
        $this->connection->begin_transaction();
    }

    /**
     *
     * @return resource
     */
    public static function get_current_transaction()
    {
        return RP_Transaction::$transaction;
    }

    /**
     *
     */
    public function close()
    {
        $this->connection->close();
        RP_Transaction::$transaction = null;
    }

    /**
     *
     */
    public function commit()
    {
        $this->connection->commit();
        $this->connection->close();
        RP_Transaction::$transaction = null;
    }


    /**
     *
     */
    public function commit_no_close()
    {
        $this->connection->commit();
    }
    /**
     *
     */
    public function rollback()
    {
        $this->connection->rollback();
        $this->connection->close();
        RP_Transaction::$transaction = null;
    }

    /**
     *
     * @return resource
     */
    public function get_connection()
    {
        return $this->connection;
    }
}


